## got 0.86

=== debian/changelog ===
got (0.86-1) unstable; urgency=medium

  * New upstream release

 -- Tobias Heider <me@tobhe.de>  Sun, 26 Mar 2023 14:52:37 +0200

got (0.84.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1031029)

 -- Tobias Heider <me@tobhe.de>  Sat, 25 Feb 2023 23:40:53 +0100

## got 0.101

=== regress/gotd/Makefile ===
.include "../../got-version.mk"

REGRESS_TARGETS=test_repo_read test_repo_read_group \
	test_repo_read_denied_user test_repo_read_denied_group \
	test_repo_read_bad_user test_repo_read_bad_group \
	test_repo_write test_repo_write_empty test_request_bad \
	test_repo_write_protected test_repo_write_readonly \
	test_email_notification test_http_notification \
	test_git_interop test_email_and_http_notification
NOOBJ=Yes
CLEANFILES=gotd.conf

.PHONY: ensure_root prepare_test_repo check_test_repo start_gotd

GOTD_TEST_ROOT=/tmp
GOTD_DEVUSER?=gotdev
GOTD_DEVUSER_HOME!=getent passwd $(GOTD_DEVUSER) | cut -d: -f6
GOTD_TEST_REPO!?=mktemp -d "$(GOTD_TEST_ROOT)/gotd-test-repo-XXXXXXXXXX"
GOTD_TEST_REPO_NAME=test-repo
GOTD_TEST_REPO_URL=ssh://${GOTD_DEVUSER}@127.0.0.1/$(GOTD_TEST_REPO_NAME)
GOTD_TEST_SMTP_PORT=2525
GOTD_TEST_HTTP_PORT=8000

GOTD_TEST_USER?=${DOAS_USER}
.if empty(GOTD_TEST_USER)
GOTD_TEST_USER=${SUDO_USER}
.endif
.if empty(GOTD_TEST_USER)
GOTD_TEST_USER=${USER}
.endif
GOTD_TEST_USER_HOME!=getent passwd $(GOTD_TEST_USER) | cut -d: -f6

# gotd.conf parameters
GOTD_USER?=got
GOTD_SOCK=${GOTD_DEVUSER_HOME}/gotd.sock

.if "${GOT_RELEASE}" == "Yes"
PREFIX ?= /usr/local
BINDIR ?= ${PREFIX}/sbin
.else
PREFIX ?= ${GOTD_TEST_USER_HOME}
BINDIR ?= ${PREFIX}/bin
.endif

GOTD_START_CMD?=env ${GOTD_ENV} $(BINDIR)/gotd -vv -f $(PWD)/gotd.conf
GOTD_STOP_CMD?=$(BINDIR)/gotctl -f $(GOTD_SOCK) stop
GOTD_TRAP=trap "$(GOTD_STOP_CMD)" HUP INT QUIT PIPE TERM

GOTD_ENV=GOT_NOTIFY_EMAIL_TIMEOUT=1

GOTD_TEST_ENV=GOTD_TEST_ROOT=$(GOTD_TEST_ROOT) \
	GOTD_TEST_REPO_URL=$(GOTD_TEST_REPO_URL) \
	GOTD_TEST_REPO_NAME=$(GOTD_TEST_REPO_NAME) \
	GOTD_TEST_REPO=$(GOTD_TEST_REPO) \
	GOTD_SOCK=$(GOTD_SOCK) \
	GOTD_DEVUSER=$(GOTD_DEVUSER) \
	GOTD_USER=$(GOTD_USER) \
	GOTD_CONF=$(PWD)/gotd.conf \
	GOTD_TEST_SMTP_PORT=$(GOTD_TEST_SMTP_PORT) \
	GOTD_TEST_HTTP_PORT=$(GOTD_TEST_HTTP_PORT) \
	HOME=$(GOTD_TEST_USER_HOME) \
	PATH=$(GOTD_TEST_USER_HOME)/bin:$(PATH)

ensure_root:
	@if [[ `id -u` -ne 0 ]]; then \
		echo gotd test suite must be started by root >&2; \
		false; \
	fi ; \
	if [[ "$(GOTD_TEST_USER)" = "root" ]]; then \
		echo GOTD_TEST_USER must be a non-root user >&2; \
		false; \
	fi

start_gotd_ro: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit ro $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

start_gotd_implicit_ro: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

start_gotd_ro_group: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit ro :$(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

# try a permit rule followed by a deny rule; last matched rule wins
start_gotd_ro_denied_user: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit ro $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo '    deny $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

# try a permit rule followed by a deny rule; last matched rule wins
start_gotd_ro_denied_group: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit ro $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo '    deny :$(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

# $GOTD_DEVUSER should not equal $GOTD_USER
start_gotd_ro_bad_user: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit ro $(GOTD_USER)' >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

# $GOTD_DEVUSER should not be in group wheel
start_gotd_ro_bad_group: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit ro :wheel' >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

start_gotd_rw: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

start_gotd_rw_protected: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo '    protect branch "foo"' >> $(PWD)/gotd.conf
	@echo '    protect tag namespace "refs/tags/"' >> $(PWD)/gotd.conf
	@echo '    protect branch "refs/heads/main"' >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

start_gotd_email_notification: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo '    notify {' >> $(PWD)/gotd.conf
	@echo -n '      email to ${GOTD_DEVUSER}' >> $(PWD)/gotd.conf
	@echo ' relay 127.0.0.1 port ${GOTD_TEST_SMTP_PORT}' >> $(PWD)/gotd.conf
	@echo "    }" >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

start_gotd_http_notification: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo '    notify {' >> $(PWD)/gotd.conf
	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" user flan password "password" insecure' >> $(PWD)/gotd.conf
	@echo "    }" >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

start_gotd_email_and_http_notification: ensure_root
	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
	@echo '    notify {' >> $(PWD)/gotd.conf
	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" user flan password "password" insecure' >> $(PWD)/gotd.conf
	@echo -n '      email to ${GOTD_DEVUSER}' >> $(PWD)/gotd.conf
	@echo ' relay 127.0.0.1 port ${GOTD_TEST_SMTP_PORT}' >> $(PWD)/gotd.conf
	@echo "    }" >> $(PWD)/gotd.conf
	@echo "}" >> $(PWD)/gotd.conf
	@$(GOTD_TRAP); $(GOTD_START_CMD)
	@$(GOTD_TRAP); sleep .5

prepare_test_repo: ensure_root
	@chown ${GOTD_USER} "${GOTD_TEST_REPO}"
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./prepare_test_repo.sh'

prepare_test_repo_empty: ensure_root
	@chown ${GOTD_USER} "${GOTD_TEST_REPO}"
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./prepare_test_repo.sh 1'

test_repo_read: prepare_test_repo start_gotd_ro
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_read.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'

test_repo_read_group: prepare_test_repo start_gotd_ro_group
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_read.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'

test_repo_read_denied_user: prepare_test_repo start_gotd_ro_denied_user
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_read_access_denied.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'

test_repo_read_denied_group: prepare_test_repo start_gotd_ro_denied_group
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_read_access_denied.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'

test_repo_read_bad_user: prepare_test_repo start_gotd_ro_bad_user
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_read_access_denied.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'

test_repo_read_bad_group: prepare_test_repo start_gotd_ro_bad_group
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_read_access_denied.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'

test_repo_write: prepare_test_repo start_gotd_rw
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_write.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'

test_repo_write_empty: prepare_test_repo_empty start_gotd_rw
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_write_empty.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'

test_repo_write_protected: prepare_test_repo start_gotd_rw_protected
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_write_protected.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'
	
test_repo_write_readonly: prepare_test_repo_empty start_gotd_implicit_ro
	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./repo_write_readonly.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null
	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'

test_request_bad: prepare_test_repo_empty start_gotd_ro
	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./request_bad.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null

test_email_notification: prepare_test_repo start_gotd_email_notification
	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./email_notification.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null

test_http_notification: prepare_test_repo start_gotd_http_notification
	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./http_notification.sh'
	@$(GOTD_STOP_CMD) 2>/dev/null

test_email_and_http_notification: prepare_test_repo start_gotd_email_and_http_notification
	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
		'env $(GOTD_TEST_ENV) sh ./http_notification.sh test_file_changed'
	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \

## got 0.91

=== debian/changelog ===
got (0.91-1) unstable; urgency=medium

  * New upstream release 0.91
  * Update copyright for 0.91

 -- Tobias Heider <me@tobhe.de>  Fri, 21 Jul 2023 16:01:19 +0200

got (0.90-1) unstable; urgency=medium

  * New upstream release 0.90

 -- Tobias Heider <me@tobhe.de>  Fri, 30 Jun 2023 11:18:32 +0200

got (0.89-1) unstable; urgency=medium

  * New upstream release 0.89

 -- Tobias Heider <me@tobhe.de>  Fri, 09 Jun 2023 12:17:38 +0200

got (0.88-1) unstable; urgency=medium

  * New upstream release

 -- Tobias Heider <me@tobhe.de>  Sun, 07 May 2023 14:17:41 +0200

=== debian/control ===
Source: got
Section: misc
Priority: optional
Maintainer: Tobias Heider <me@tobhe.de>
Build-Depends: debhelper-compat (= 13), pkg-config, libbsd-dev, libmd-dev, libncurses-dev, libevent-dev, uuid-dev, zlib1g-dev, libssl-dev
Standards-Version: 4.6.2
Homepage: https://gameoftrees.org/index.html
Vcs-Browser: https://salsa.debian.org/debian/got
Vcs-Git: https://salsa.debian.org/debian/got.git
Rules-Requires-Root: no

Package: got
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: VCS which prioritizes ease of use and simplicity over flexibility
 Game of Trees (Got) is a version control system which prioritizes
 ease of use and simplicity over flexibility.
 Got uses Git repositories to store versioned data. Git can be used
 for any functionality which has not yet been implemented in
 Got. It will always remain possible to work with both Got and Git
 on the same repository.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --without autoreconf

## got 0.95

=== debian/changelog ===
got (0.95-1build1) noble; urgency=medium

  * No-change rebuild for libevent t64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 01 Apr 2024 10:15:08 +0200

got (0.95-1) unstable; urgency=medium

  [ Ryan Kavanagh ]
  * Update copyright years

  [ Tobias Heider ]
  * New upstream version 0.95
  * Silence lintian warnings

 -- Tobias Heider <me@tobhe.de>  Mon, 11 Dec 2023 14:00:41 +0100

got (0.94-1) unstable; urgency=medium

  * New upstream version 0.94

 -- Tobias Heider <me@tobhe.de>  Fri, 01 Dec 2023 14:30:52 +0100

got (0.93-1) unstable; urgency=medium

  * New upstream release 0.93
  * Install gotd example config with dh_installexamples(1)
  * Add new gotd binary package for Game of Trees daemon

 -- Tobias Heider <me@tobhe.de>  Fri, 29 Sep 2023 15:18:57 +0200

=== debian/control ===
Source: got
Section: misc
Priority: optional
Maintainer: Tobias Heider <me@tobhe.de>
Build-Depends: debhelper-compat (= 13), pkg-config, libbsd-dev, libmd-dev,
 libncurses-dev, libevent-dev, uuid-dev, zlib1g-dev, libssl-dev, bison
Standards-Version: 4.6.2
Homepage: https://gameoftrees.org/index.html
Vcs-Browser: https://salsa.debian.org/debian/got
Vcs-Git: https://salsa.debian.org/debian/got.git
Rules-Requires-Root: no

Package: got
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: game of trees version control system
 Game of Trees (Got) is a version control system which prioritizes
 ease of use and simplicity over flexibility.
 Got uses Git repositories to store versioned data. Git can be used
 for any functionality which has not yet been implemented in
 Got. It will always remain possible to work with both Got and Git
 on the same repository.
 .
 This package provides the got, tog and gotadmin command line tools.

Package: gotd
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, adduser
Recommends: openssh-server
Description: game of trees repository server
 Game of Trees (Got) is a version control system which prioritizes
 ease of use and simplicity over flexibility.
 Got uses Git repositories to store versioned data. Git can be used
 for any functionality which has not yet been implemented in
 Got. It will always remain possible to work with both Got and Git
 on the same repository.
 . 
 This package provides the gotd server, the gotctl command line tool
 and the gotsh shell.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

confflags += --enable-gotd
confflags += --with-gotd-empty-path=/var/lib/gotd/empty

%:
	dh $@ --without autoreconf

override_dh_auto_configure:
	dh_auto_configure -- $(confflags)

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

## got 0.100

=== debian/changelog ===
got (0.100-1) unstable; urgency=medium

  * New upstream version 0.100
  * Update copyright for new additions

 -- Tobias Heider <me@tobhe.de>  Thu, 13 Jun 2024 23:29:58 +0200

got (0.99-1) unstable; urgency=medium

  * New upstream version 0.99

 -- Tobias Heider <me@tobhe.de>  Mon, 13 May 2024 08:31:09 +0200

got (0.98.2-1) unstable; urgency=medium

  * New upstream version 0.98.2
  * Install new libexec helper binaries in got and gotd
  * Update and deduplicate copyright
  * Fix man page reference in gotd.README.debian
  * Drop --without autoreconf 

 -- Tobias Heider <me@tobhe.de>  Fri, 26 Apr 2024 16:39:45 +0200

got (0.97-1) unstable; urgency=medium

  * New upstream version 0.97
  * Update pkg-config to pkgconf

 -- Tobias Heider <me@tobhe.de>  Sun, 24 Mar 2024 19:06:13 +0100

got (0.96-1) unstable; urgency=medium

  * New upstream version 0.96

 -- Tobias Heider <me@tobhe.de>  Mon, 04 Mar 2024 17:13:06 +0100

## got 0.101

=== debian/changelog ===
got (0.101-1) unstable; urgency=medium

  * New upstream version 0.101

 -- Tobias Heider <me@tobhe.de>  Fri, 19 Jul 2024 12:20:56 +0200

## got 0.103

=== regress/Makefile ===
SUBDIR = cmdline delta deltify idset path fetch tog secrets

.if make(clean)
SUBDIR += gotd 
.endif

.include <bsd.subdir.mk>

=== regress/gotd/Makefile ===
--- 
+++ 
@@ -6,11 +6,12 @@
 	test_repo_write test_repo_write_empty test_request_bad \
 	test_repo_write_protected test_repo_write_readonly \
 	test_email_notification test_http_notification \
-	test_git_interop test_email_and_http_notification
+	test_git_interop test_email_and_http_notification \
+	test_http_notification_hmac
 NOOBJ=Yes
-CLEANFILES=gotd.conf
-
-.PHONY: ensure_root prepare_test_repo check_test_repo start_gotd
+CLEANFILES=gotd.conf gotd-secrets.conf
+
+.PHONY: ensure_root ensure_secrets prepare_test_repo check_test_repo start_gotd
 
 GOTD_TEST_ROOT=/tmp
 GOTD_DEVUSER?=gotdev
@@ -20,6 +21,7 @@
 GOTD_TEST_REPO_URL=ssh://${GOTD_DEVUSER}@127.0.0.1/$(GOTD_TEST_REPO_NAME)
 GOTD_TEST_SMTP_PORT=2525
 GOTD_TEST_HTTP_PORT=8000
+GOTD_TEST_HMAC_SECRET!=openssl rand -base64 32
 
 GOTD_TEST_USER?=${DOAS_USER}
 .if empty(GOTD_TEST_USER)
@@ -58,6 +60,7 @@
 	GOTD_CONF=$(PWD)/gotd.conf \
 	GOTD_TEST_SMTP_PORT=$(GOTD_TEST_SMTP_PORT) \
 	GOTD_TEST_HTTP_PORT=$(GOTD_TEST_HTTP_PORT) \
+	GOTD_TEST_HMAC_SECRET=$(GOTD_TEST_HMAC_SECRET) \
 	HOME=$(GOTD_TEST_USER_HOME) \
 	PATH=$(GOTD_TEST_USER_HOME)/bin:$(PATH)
 
@@ -71,6 +74,12 @@
 		false; \
 	fi
 
+ensure_secrets:
+	@echo 'auth flan user flan password password' > $(PWD)/gotd-secrets.conf
+	@echo 'hmac flan ${GOTD_TEST_HMAC_SECRET}' >> $(PWD)/gotd-secrets.conf
+	@chown root:0 $(PWD)/gotd-secrets.conf
+	@chmod 600 $(PWD)/gotd-secrets.conf
+
 start_gotd_ro: ensure_root
 	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
 	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
@@ -183,32 +192,45 @@
 	@$(GOTD_TRAP); $(GOTD_START_CMD)
 	@$(GOTD_TRAP); sleep .5
 
-start_gotd_http_notification: ensure_root
-	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
-	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
-	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
-	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
-	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
-	@echo '    notify {' >> $(PWD)/gotd.conf
-	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" user flan password "password" insecure' >> $(PWD)/gotd.conf
-	@echo "    }" >> $(PWD)/gotd.conf
-	@echo "}" >> $(PWD)/gotd.conf
-	@$(GOTD_TRAP); $(GOTD_START_CMD)
-	@$(GOTD_TRAP); sleep .5
-
-start_gotd_email_and_http_notification: ensure_root
-	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
-	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
-	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
-	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
-	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
-	@echo '    notify {' >> $(PWD)/gotd.conf
-	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" user flan password "password" insecure' >> $(PWD)/gotd.conf
+start_gotd_http_notification: ensure_root ensure_secrets
+	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
+	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
+	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
+	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
+	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
+	@echo '    notify {' >> $(PWD)/gotd.conf
+	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" auth flan insecure' >> $(PWD)/gotd.conf
+	@echo "    }" >> $(PWD)/gotd.conf
+	@echo "}" >> $(PWD)/gotd.conf
+	@$(GOTD_TRAP); $(GOTD_START_CMD) -s $(PWD)/gotd-secrets.conf
+	@$(GOTD_TRAP); sleep .5
+
+start_gotd_email_and_http_notification: ensure_root ensure_secrets
+	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
+	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
+	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
+	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
+	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
+	@echo '    notify {' >> $(PWD)/gotd.conf
+	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" auth flan insecure' >> $(PWD)/gotd.conf
 	@echo -n '      email to ${GOTD_DEVUSER}' >> $(PWD)/gotd.conf
 	@echo ' relay 127.0.0.1 port ${GOTD_TEST_SMTP_PORT}' >> $(PWD)/gotd.conf
 	@echo "    }" >> $(PWD)/gotd.conf
 	@echo "}" >> $(PWD)/gotd.conf
-	@$(GOTD_TRAP); $(GOTD_START_CMD)
+	@$(GOTD_TRAP); $(GOTD_START_CMD) -s $(PWD)/gotd-secrets.conf
+	@$(GOTD_TRAP); sleep .5
+
+start_gotd_http_notification_hmac: ensure_root ensure_secrets
+	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
+	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
+	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
+	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
+	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
+	@echo '    notify {' >> $(PWD)/gotd.conf
+	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" auth flan insecure hmac flan' >> $(PWD)/gotd.conf
+	@echo "    }" >> $(PWD)/gotd.conf
+	@echo "}" >> $(PWD)/gotd.conf
+	@$(GOTD_TRAP); $(GOTD_START_CMD) -s $(PWD)/gotd-secrets.conf
 	@$(GOTD_TRAP); sleep .5
 
 prepare_test_repo: ensure_root
@@ -274,27 +296,3 @@
 	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'
 	
 test_repo_write_readonly: prepare_test_repo_empty start_gotd_implicit_ro
-	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./repo_write_readonly.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'
-
-test_request_bad: prepare_test_repo_empty start_gotd_ro
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./request_bad.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-
-test_email_notification: prepare_test_repo start_gotd_email_notification
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./email_notification.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-
-test_http_notification: prepare_test_repo start_gotd_http_notification
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./http_notification.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-
-test_email_and_http_notification: prepare_test_repo start_gotd_email_and_http_notification
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./http_notification.sh test_file_changed'
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \

=== debian/changelog ===
got (0.103-1) unstable; urgency=medium

  * New upstream version 0.103
  * Install gotd-secrets.conf(5) with gotd

 -- Tobias Heider <me@tobhe.de>  Tue, 10 Sep 2024 19:36:40 +0200

## got 0.106

=== debian/changelog ===
got (0.106-1) unstable; urgency=medium

  * New upstream version 0.106

 -- Tobias Heider <me@tobhe.de>  Fri, 29 Nov 2024 15:10:43 +0100

## got 0.109

=== regress/Makefile ===
SUBDIR = cmdline delta deltify idset path fetch tog secrets

.if make(clean) || make(obj)
SUBDIR += gotd gotwebd
.endif

.include <bsd.subdir.mk>

=== regress/cmdline/Makefile ===
REGRESS_TARGETS=checkout update status log add rm diff blame branch tag \
	ref commit revert cherrypick backout rebase init import histedit \
	integrate merge stage unstage cat clone fetch send tree patch pack \
	cleanup dump load memleak
NOOBJ=Yes

GOT_TEST_ROOT=/tmp

checkout:
	./checkout.sh -q -r "$(GOT_TEST_ROOT)"

update:
	./update.sh -q -r "$(GOT_TEST_ROOT)"

status:
	./status.sh -q -r "$(GOT_TEST_ROOT)"

log:
	./log.sh -q -r "$(GOT_TEST_ROOT)"

add:
	./add.sh -q -r "$(GOT_TEST_ROOT)"

rm:
	./rm.sh -q -r "$(GOT_TEST_ROOT)"

diff:
	./diff.sh -q -r "$(GOT_TEST_ROOT)"

blame:
	./blame.sh -q -r "$(GOT_TEST_ROOT)"

branch:
	./branch.sh -q -r "$(GOT_TEST_ROOT)"

tag:
	./tag.sh -q -r "$(GOT_TEST_ROOT)"

ref:
	./ref.sh -q -r "$(GOT_TEST_ROOT)"

commit:
	./commit.sh -q -r "$(GOT_TEST_ROOT)"

revert:
	./revert.sh -q -r "$(GOT_TEST_ROOT)"

cherrypick:
	./cherrypick.sh -q -r "$(GOT_TEST_ROOT)"

backout:
	./backout.sh -q -r "$(GOT_TEST_ROOT)"

rebase:
	./rebase.sh -q -r "$(GOT_TEST_ROOT)"

init:
	./init.sh -q -r "$(GOT_TEST_ROOT)"

import:
	./import.sh -q -r "$(GOT_TEST_ROOT)"

histedit:
	./histedit.sh -q -r "$(GOT_TEST_ROOT)"

integrate:
	./integrate.sh -q -r "$(GOT_TEST_ROOT)"

merge:
	./merge.sh -q -r "$(GOT_TEST_ROOT)"

stage:
	./stage.sh -q -r "$(GOT_TEST_ROOT)"

unstage:
	./unstage.sh -q -r "$(GOT_TEST_ROOT)"

cat:
	./cat.sh -q -r "$(GOT_TEST_ROOT)"

clone:
	./clone.sh -q -r "$(GOT_TEST_ROOT)"

fetch:
	./fetch.sh -q -r "$(GOT_TEST_ROOT)"

send:
	./send.sh -q -r "$(GOT_TEST_ROOT)"

tree:
	./tree.sh -q -r "$(GOT_TEST_ROOT)"

patch:
	./patch.sh -q -r "$(GOT_TEST_ROOT)"

pack:
	./pack.sh -q -r "$(GOT_TEST_ROOT)"

cleanup:
	./cleanup.sh -q -r "$(GOT_TEST_ROOT)"

dump:
	./dump.sh -q -r "$(GOT_TEST_ROOT)"

load:
	./load.sh -q -r "$(GOT_TEST_ROOT)"

memleak:
	./memleak.sh -q -r "$(GOT_TEST_ROOT)"

.include <bsd.regress.mk>

=== regress/gotd/Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 GOTD_TEST_ROOT=/tmp
 GOTD_DEVUSER?=gotdev
 GOTD_DEVUSER_HOME!=getent passwd $(GOTD_DEVUSER) | cut -d: -f6
-GOTD_TEST_REPO!?=mktemp -d "$(GOTD_TEST_ROOT)/gotd-test-repo-XXXXXXXXXX"
+GOTD_TEST_REPO!!=mktemp -d "$(GOTD_TEST_ROOT)/gotd-test-repo-XXXXXXXXXX"
 GOTD_TEST_REPO_NAME=test-repo
 GOTD_TEST_REPO_URL=ssh://${GOTD_DEVUSER}@127.0.0.1/$(GOTD_TEST_REPO_NAME)
 GOTD_TEST_SMTP_PORT=2525
@@ -48,7 +48,7 @@
 GOTD_STOP_CMD?=$(BINDIR)/gotctl -f $(GOTD_SOCK) stop
 GOTD_TRAP=trap "$(GOTD_STOP_CMD)" HUP INT QUIT PIPE TERM
 
-GOTD_ENV=GOT_NOTIFY_EMAIL_TIMEOUT=1
+GOTD_ENV=GOT_NOTIFY_TIMEOUT=10
 
 GOTD_TEST_ENV=GOTD_TEST_ROOT=$(GOTD_TEST_ROOT) \
 	GOTD_TEST_REPO_URL=$(GOTD_TEST_REPO_URL) \
@@ -171,9 +171,9 @@
 	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
 	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
 	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
-	@echo '    protect branch "foo"' >> $(PWD)/gotd.conf
+	@echo '    protect branch foo' >> $(PWD)/gotd.conf
 	@echo '    protect tag namespace "refs/tags/"' >> $(PWD)/gotd.conf
-	@echo '    protect branch "refs/heads/main"' >> $(PWD)/gotd.conf
+	@echo '    protect { branch refs/heads/main }' >> $(PWD)/gotd.conf
 	@echo "}" >> $(PWD)/gotd.conf
 	@$(GOTD_TRAP); $(GOTD_START_CMD)
 	@$(GOTD_TRAP); sleep .5

=== regress/gotwebd/Makefile ===
.PATH:${.CURDIR}/../../lib

REGRESS_TARGETS=test_gotwebd test_gotwebd_paginate

PROG = gotwebd_test
SRCS = gotwebd_test.c error.c hash.c pollfd.c

CPPFLAGS = -I${.CURDIR}/../../include -I${.CURDIR}/../../lib

NOMAN = yes

.PHONY: ensure_root prepare_test_env prepare_test_repo start_gotwebd \
	gotwebd_test_conf gotwebd_test_conf_paginate

GOTWEBD_TEST_TMPDIR=/tmp
GOTWEBD_TEST_ROOT?!!=mktemp -d "${GOTWEBD_TEST_TMPDIR}/gotwebd-test-XXXXXXXXXX"
GOTWEBD_TEST_CHROOT=${GOTWEBD_TEST_ROOT}/var/www
GOTWEBD_TEST_CONF=${GOTWEBD_TEST_ROOT}/gotwebd.conf
GOTWEBD_TEST_SOCK=${GOTWEBD_TEST_CHROOT}/gotweb.sock
GOTWEBD_TEST_FCGI=${.OBJDIR}/${PROG}
GOTWEBD_TEST_PAGINATE_NITEMS?=15  # must be a multiple of 3 (items per page)
GOTWEBD_CHECK_MEMLEAK=export MALLOC_OPTIONS=1; ktrace -d -tu -i -f ${GOTWEBD_TEST_ROOT}/ktrace.out

GOTWEBD_TEST_USER?=${DOAS_USER}
.if empty(GOTWEBD_TEST_USER)
GOTWEBD_TEST_USER=${SUDO_USER}
.endif
.if empty(GOTWEBD_TEST_USER)
GOTWEBD_TEST_USER=${USER}
.endif

GOTWEBD_TEST_USER_HOME!=getent passwd ${GOTWEBD_TEST_USER} | cut -d: -f6

PREFIX ?= /usr/local
BINDIR ?= ${PREFIX}/sbin

GOTWEBD_START_CMD?=${BINDIR}/gotwebd -vvf ${GOTWEBD_TEST_CONF}
GOTWEBD_STOP_CMD?=pkill -TERM -fx '${GOTWEBD_START_CMD}'
GOTWEBD_TRAP=trap "${GOTWEBD_STOP_CMD}" HUP INT QUIT PIPE TERM

GOTWEBD_TEST_ENV=GOTWEBD_TEST_SOCK=${GOTWEBD_TEST_SOCK} \
	GOTWEBD_TEST_CHROOT=${GOTWEBD_TEST_CHROOT} \
	GOTWEBD_TEST_ROOT=${GOTWEBD_TEST_ROOT} \
	GOTWEBD_TEST_CONF=${GOTWEBD_TEST_CONF} \
	GOTWEBD_TEST_USER=${GOTWEBD_TEST_USER} \
	GOTWEBD_TEST_FCGI=${GOTWEBD_TEST_FCGI} \
	GOTWEBD_TEST_PAGINATE_NITEMS=${GOTWEBD_TEST_PAGINATE_NITEMS} \
	PATH=$(GOTWEBD_TEST_USER_HOME)/bin:${PATH} \
	HOME=$(GOTWEBD_TEST_USER_HOME) \
	GOTWEBD_TEST_DATA_DIR=${.CURDIR}

ensure_root:
	@if [[ `id -u` -ne 0 ]]; then \
		echo gotwebd test suite must be started by root >&2; \
		false; \
	fi ; \
	if [[ "${GOTWEBD_TEST_USER}" = "root" ]]; then \
		echo GOTWEBD_TEST_USER must be a non-root user >&2; \
		false; \
	fi

gotwebd_libexec:
	@su -m ${GOTWEBD_TEST_USER} -c \
	    '${MAKE} -C ${.CURDIR}/../../gotwebd/libexec' >/dev/null 2>&1

prepare_test_env: ensure_root gotwebd_libexec
	@mkdir -p "${GOTWEBD_TEST_CHROOT}"
	@DESTDIR=${GOTWEBD_TEST_ROOT} \
	    ${MAKE} -C ${.CURDIR}/../../gotwebd/libexec install >/dev/null 2>&1
	@chown ${GOTWEBD_TEST_USER} "${GOTWEBD_TEST_ROOT}" \
	    "${GOTWEBD_TEST_CHROOT}"

prepare_test_repo: prepare_test_env
	@su -m ${GOTWEBD_TEST_USER} -c 'env ${GOTWEBD_TEST_ENV} \
	    sh ${.CURDIR}/prepare_test_repo.sh "${GOTWEBD_TEST_CHROOT}"'

gotwebd_test_conf:
	@echo 'user "${GOTWEBD_TEST_USER}"' > ${GOTWEBD_TEST_CONF}
	@echo 'chroot "${GOTWEBD_TEST_CHROOT}"' >> ${GOTWEBD_TEST_CONF}
	@echo 'listen on socket "${GOTWEBD_TEST_SOCK}"' >> ${GOTWEBD_TEST_CONF}
	@echo 'server "localhost" {' >> ${GOTWEBD_TEST_CONF}
	@echo '    show_repo_owner off' >> ${GOTWEBD_TEST_CONF}
	@echo '}' >> ${GOTWEBD_TEST_CONF}

gotwebd_test_conf_paginate: gotwebd_test_conf
	@printf '5i\n    max_commits_display 3\n.\nwq\n' | \
	    ed -s ${GOTWEBD_TEST_CONF}

start_gotwebd: prepare_test_repo gotwebd_test
	@${GOTWEBD_TRAP}; ${GOTWEBD_CHECK_MEMLEAK} ${GOTWEBD_START_CMD}
	@${GOTWEBD_TRAP}; sleep .5

test_gotwebd: gotwebd_test_conf start_gotwebd
	@-$(GOTWEBD_TRAP); su -m ${GOTWEBD_TEST_USER} -c \
		'env $(GOTWEBD_TEST_ENV) sh ${.CURDIR}/test_gotwebd.sh'
	@${GOTWEBD_STOP_CMD} 2>/dev/null
	@kdump -u malloc -f ${GOTWEBD_TEST_ROOT}/ktrace.out \
		> ${GOTWEBD_TEST_ROOT}/leak-report && \
	if grep -q "/gotwebd 0x" ${GOTWEBD_TEST_ROOT}/leak-report; then \
		cat ${GOTWEBD_TEST_ROOT}/leak-report; \
		exit 1; \
	fi

test_gotwebd_paginate: gotwebd_test_conf_paginate start_gotwebd
	@-${GOTWEBD_TRAP}; su -m ${GOTWEBD_TEST_USER} -c \
	    'env ${GOTWEBD_TEST_ENV} sh ${.CURDIR}/test_gotwebd_paginate.sh'
	@${GOTWEBD_STOP_CMD} 2>/dev/null
	@kdump -u malloc -f ${GOTWEBD_TEST_ROOT}/ktrace.out \
	    > ${GOTWEBD_TEST_ROOT}/leak-report && \
	if grep -q "/gotwebd 0x" ${GOTWEBD_TEST_ROOT}/leak-report; then \
		cat ${GOTWEBD_TEST_ROOT}/leak-report; \
		exit 1; \
	fi

.include <bsd.regress.mk>

=== regress/template/Makefile ===
REGRESS_TARGETS =	00-empty \
			01-noise-only \
			02-only-verbatim \
			03-block \
			04-flow \
			05-loop \
			06-escape \
			07-printf \
			08-dangling

REGRESS_CLEANUP =	clean-comp
NO_OBJ =		Yes

CFLAGS +=		-I../../template

.PATH:../../template

clean-comp:
	rm -f t got 0*.[cdo] runbase.[do] runlist.[do] tmpl.*

.SUFFIXES: .tmpl .c .o

.tmpl.c:
	../../template/obj/template -o $@ $<

00-empty:
	../../template/obj/template 00-empty.tmpl >/dev/null

01-noise-only:
	../../template/obj/template 01-noise-only.tmpl >/dev/null

02-only-verbatim: 02-only-verbatim.o tmpl.o
	${CC} 02-only-verbatim.o tmpl.o -o t && ./t > got
	diff -u ${.CURDIR}/02.expected got

03-block: 03-block.o runbase.o tmpl.o
	${CC} 03-block.o runbase.o tmpl.o -o t && ./t > got
	diff -u ${.CURDIR}/03.expected got

04-flow: 04-flow.o runbase.o tmpl.o
	${CC} 04-flow.o runbase.o tmpl.o -o t && ./t > got
	diff -u ${.CURDIR}/04.expected got

05-loop: 05-loop.o runlist.o tmpl.o
	${CC} 05-loop.o runlist.o tmpl.o -o t && ./t > got
	diff -u ${.CURDIR}/05.expected got

06-escape: 06-escape.o runbase.o tmpl.o
	${CC} 06-escape.o runbase.o tmpl.o -o t && ./t > got
	diff -u ${.CURDIR}/06.expected got

07-printf: 07-printf.o runbase.o tmpl.o
	${CC} 07-printf.o runbase.o tmpl.o -o t && ./t > got
	diff -u ${.CURDIR}/07.expected got

08-dangling: 08-dangling.o runbase.o tmpl.o
	${CC} 08-dangling.o runbase.o tmpl.o -o t && ./t > got
	diff -u ${.CURDIR}/08.expected got

.include <bsd.regress.mk>

=== debian/changelog ===
got (0.109-3) unstable; urgency=medium

  * Fix bug in got clone/fetch against Git servers which do not speak English

 -- Tobias Heider <me@tobhe.de>  Thu, 13 Mar 2025 16:43:00 +0100

got (0.109-2) unstable; urgency=medium

  * Backport inifinte loop regression fix from 0.110

 -- Tobias Heider <me@tobhe.de>  Thu, 13 Mar 2025 16:20:01 +0100

got (0.109-1) unstable; urgency=medium

  * Update copyright
  * New upstream version 0.109

 -- Tobias Heider <me@tobhe.de>  Tue, 11 Mar 2025 00:22:46 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: misc
 Priority: optional
 Maintainer: Tobias Heider <me@tobhe.de>
-Build-Depends: debhelper-compat (= 13), pkg-config, libbsd-dev, libmd-dev,
- libncurses-dev, libevent-dev, uuid-dev, zlib1g-dev, libssl-dev, bison
+Build-Depends: debhelper-compat (= 13), pkgconf, libbsd-dev, libmd-dev,
+ libncurses-dev, libevent-dev, libtls-dev, uuid-dev, zlib1g-dev, libssl-dev,
+ bison
 Standards-Version: 4.6.2
 Homepage: https://gameoftrees.org/index.html
 Vcs-Browser: https://salsa.debian.org/debian/got

## got 0.111

=== regress/gotd/Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 	test_repo_write_protected test_repo_write_readonly \
 	test_email_notification test_http_notification \
 	test_git_interop test_email_and_http_notification \
-	test_http_notification_hmac
+	test_http_notification_hmac test_connection_limit
 NOOBJ=Yes
 CLEANFILES=gotd.conf gotd-secrets.conf
 
@@ -233,6 +233,17 @@
 	@$(GOTD_TRAP); $(GOTD_START_CMD) -s $(PWD)/gotd-secrets.conf
 	@$(GOTD_TRAP); sleep .5
 
+start_gotd_connection_limit: ensure_root
+	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
+	@echo 'connection limit user ${GOTD_DEVUSER} 2' >> $(PWD)/gotd.conf
+	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
+	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
+	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
+	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
+	@echo "}" >> $(PWD)/gotd.conf
+	@$(GOTD_TRAP); $(GOTD_START_CMD)
+	@$(GOTD_TRAP); sleep .5
+
 prepare_test_repo: ensure_root
 	@chown ${GOTD_USER} "${GOTD_TEST_REPO}"
 	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./prepare_test_repo.sh'
@@ -285,14 +296,3 @@
 
 test_repo_write_empty: prepare_test_repo_empty start_gotd_rw
 	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./repo_write_empty.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'
-
-test_repo_write_protected: prepare_test_repo start_gotd_rw_protected
-	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./repo_write_protected.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'
-	
-test_repo_write_readonly: prepare_test_repo_empty start_gotd_implicit_ro

=== regress/gotsysd/Makefile ===
.include "../../got-version.mk"

REGRESS_TARGETS=test_gotsysd

REGRESS_SETUP_ONCE=setup_test_vm
REGRESS_CLEANUP=stop_test_vm

NOOBJ=Yes
CLEANFILES= SHA256.sig bsd.rd bsd.rd.fs bsd.rd.decomp ${AUTOINSTALL_CONF} \
	${GOTSYSD_BSD_RD} ${GOTSYSD_SSH_KEY} ${GOTSYSD_SSH_PUBKEY} \
	${GOTSYSD_TEST_VM_BASE_IMAGE} ${GOTSYSD_VM_PASSWD_FILE} ${GOTD_CONF} \
	${GOTSYSD_CONF} ${GOTSYS_CONF} ${GOT_CONF} ${INSTALL_SITE}

.PHONY: ensure_root vm start_test_vm

GOTSYSD_TEST_ROOT=/tmp
GOTSYSD_TEST_DIR!!=mktemp -d "$(GOTSYSD_TEST_ROOT)/gotsysd-test-XXXXXXXXXX"
GOTSYSD_TEST_VM_BASE_IMAGE=gotsysd_test_vm_base.qcow2
GOTSYSD_BSD_RD=gotsysd_bsd.rd
GOTSYSD_VND?=vnd0
GOTSYSD_MIRROR?=cdn.openbsd.org
GOTSYSD_MIRROR_URL?=https://${GOTSYSD_MIRROR}/pub/OpenBSD
GOTSYSD_OPENBSD_VERSION?=snapshots
GOTSYSD_VM_NAME=gotsysd-test
GOTSYSD_VM_PASSWORD?=gameoftrees
GOTSYSD_VM_PASSWD_FILE=gotsysd_vm_passwd
GOTD_CONF=gotd.conf
GOTD_UID=501	# /usr/ports/infrastructure/db/user.list
GOTSYSD_CONF=gotsysd.conf
GOTSYSD_UID=600	# /usr/ports/infrastructure/db/user.list
GOTSYS_CONF=gotsys.conf
GOT_CONF=got.conf
GOTSYS_REPO=gotsys.git

GOTSYSD_TEST_USER?=${DOAS_USER}
.if empty(GOTSYSD_TEST_USER)
GOTSYSD_TEST_USER=${SUDO_USER}
.endif
.if empty(GOTSYSD_TEST_USER)
GOTSYSD_TEST_USER=${USER}
.endif
GOTSYSD_TEST_USER_HOME!=getent passwd $(GOTSYSD_TEST_USER) | cut -d: -f6

GOTSYSD_DEV_USER=flan_hacker
GOTSYSD_DEV_PASSWORD=hack1234

GOTSYSD_TEST_ENV=GOTSYSD_TEST_ROOT=${GOTSYSD_TEST_ROOT} \
	GOTSYSD_TEST_DIR=$(GOTSYSD_TEST_DIR) \
	GOTSYSD_TEST_USER=$(GOTSYSD_TEST_USER) \
	GOTSYSD_VM_PASSWORD=$(GOTSYSD_VM_PASSWORD) \
	GOTSYSD_DEV_USER=$(GOTSYSD_DEV_USER) \
	GOTSYSD_DEV_PASSWORD=$(GOTSYSD_DEV_PASSWORD) \
	GOTSYSD_SSH_KEY=${GOTSYSD_SSH_KEY} \
	GOTSYSD_SSH_PUBKEY=${GOTSYSD_SSH_PUBKEY} \
	GOTSYS_REPO=${GOTSYS_REPO} \
	HOME=$(GOTSYSD_TEST_USER_HOME) \
	PATH=$(GOTSYSD_TEST_USER_HOME)/bin:$(PATH)


UNPRIV=su -m ${GOTSYSD_TEST_USER} -c
AUTOINSTALL_CONF=auto_install.conf
INSTALL_SITE=install.site
GOTSYSD_SSH_KEY=gotsysd_sshkey
GOTSYSD_SSH_PUBKEY=gotsysd_sshkey.pub
GOTSYSD_SSH_OPTIONS= -i ${GOTSYSD_SSH_KEY} -o StrictHostKeyChecking=accept-new
GOTSYSD_SSH_CMD= ssh ${GOTSYSD_SSH_OPTIONS}
GOTSYSD_SCP_CMD= scp ${GOTSYSD_SSH_OPTIONS} -B -C -q

.if "${GOT_RELEASE}" == "Yes"
PREFIX ?= /usr/local
BINDIR ?= ${PREFIX}/sbin
.else
PREFIX ?= ${GOTSYSD_TEST_USER_HOME}
BINDIR ?= ${PREFIX}/bin
.endif

ensure_root:
	@if [[ `id -u` -ne 0 ]]; then \
		echo gotsysd test suite must be started by root >&2; \
		false; \
	fi ; \
	if [[ "$(GOTSYSD_TEST_USER)" = "root" ]]; then \
		echo GOTSYSD_TEST_USER must be a non-root user >&2; \
		false; \
	fi

ensure_ipforwarding:
	@if [[ `sysctl -n net.inet.ip.forwarding` -ne 1 ]]; then \
		echo IPv4 forwarding should be enabled first: sysctl net.inet.ip.forwarding=1 >&2; \
		false; \
	fi ; \

bsd.rd:
	${UNPRIV} "ftp -o SHA256.sig \
		${GOTSYSD_MIRROR_URL}/${GOTSYSD_OPENBSD_VERSION}/`uname -m`/SHA256.sig"
	${UNPRIV} "ftp -o bsd.rd \
		${GOTSYSD_MIRROR_URL}/${GOTSYSD_OPENBSD_VERSION}/`uname -m`/bsd.rd" \
	${UNPRIV} "set -e; \
		KEY=$$(head -1 < SHA256.sig | cut -d' ' -f5 | \
		egrep '^openbsd-[[:digit:]]{2,3}-base.pub$$' || true); \
		signify -C -p /etc/signify/$${KEY} -x SHA256.sig bsd.rd"

${GOTSYSD_SSH_PUBKEY}:
	${UNPRIV} "ssh-keygen -q -f ${GOTSYSD_SSH_KEY} -P '' \
		-C 'temporary-gotsysd-regress-ssh-key'"

${GOTSYSD_VM_PASSWD_FILE}:
	${UNPRIV} "touch ${GOTSYSD_VM_PASSWD_FILE}"
	${UNPRIV} "chmod 700 ${GOTSYSD_VM_PASSWD_FILE}"
	@${UNPRIV} "echo ${GOTSYSD_VM_PASSWORD} | encrypt > $@"

${AUTOINSTALL_CONF}: ${GOTSYSD_VM_PASSWD_FILE} ${GOTSYSD_SSH_PUBKEY}
	${UNPRIV} "echo System hostname = $(GOTSYSD_VM_NAME) > $@"
	${UNPRIV} "echo -n 'Password for root = ' >> $@"
	${UNPRIV} "cat ${GOTSYSD_VM_PASSWD_FILE} >> $@"
	${UNPRIV} "echo -n 'Public ssh key for root account = ' >> $@"
	${UNPRIV} "cat ${GOTSYSD_SSH_PUBKEY} >> $@"
	${UNPRIV} "echo Allow root ssh login? = prohibit-password >> $@"
	${UNPRIV} "echo Setup a user = ${GOTSYSD_TEST_USER} >> $@"
	${UNPRIV} "echo -n 'Password for user ${GOTSYSD_TEST_USER}? = ' >> $@"
	${UNPRIV} "cat ${GOTSYSD_VM_PASSWD_FILE} >> $@"
	${UNPRIV} "echo -n 'Public ssh key for user = ' >> $@"
	${UNPRIV} "cat ${GOTSYSD_SSH_PUBKEY} >> $@"
	${UNPRIV} "echo Location of sets = http >> $@"
	${UNPRIV} "echo Server directory = pub/OpenBSD/${GOTSYSD_OPENBSD_VERSION}/`uname -m` >> $@"
	${UNPRIV} "echo HTTP Server = ${GOTSYSD_MIRROR} >> $@"

${INSTALL_SITE}:
	${UNPRIV} "echo 'echo library_aslr=NO >> /etc/rc.conf.local' >> $@" 
	${UNPRIV} "echo sed -i \'/\\\/usr\\\/libexec\\\/reorder_kernel/d\' /etc/rc >> $@" 
	
${GOTSYSD_BSD_RD}: bsd.rd ${AUTOINSTALL_CONF} ${INSTALL_SITE}
	${UNPRIV} "gzcat bsd.rd > bsd.rd.decomp"
	rdsetroot -x bsd.rd.decomp bsd.rd.fs
	vnconfig ${GOTSYSD_VND} bsd.rd.fs
	mount /dev/${GOTSYSD_VND}a /mnt
	cp ${AUTOINSTALL_CONF} /mnt/auto_install.conf
	install -o root -m 755 ${INSTALL_SITE} /mnt/install.site
	sed -i 's/if \[\[ -x \/mnt\/$$MODE.site \]\]; then/if cp \/install.site \/mnt\/install.site; then/' /mnt/install.sub
	umount /mnt
	vnconfig -u ${GOTSYSD_VND}
	rdsetroot bsd.rd.decomp bsd.rd.fs
	mv bsd.rd.decomp $@

${GOTSYSD_TEST_VM_BASE_IMAGE}:
	vmctl create -s 4G $@

# Install the base VM image. This target should be run interactively.
vm: ensure_root ensure_ipforwarding ${GOTSYSD_TEST_VM_BASE_IMAGE} ${GOTSYSD_BSD_RD}
	vmctl start -d ${GOTSYSD_TEST_VM_BASE_IMAGE} \
		-b $(GOTSYSD_BSD_RD) -c -L ${GOTSYSD_VM_NAME}

start_test_vm: ensure_root ensure_ipforwarding
	@set -e; \
	vmctl create -b ${.CURDIR}/${GOTSYSD_TEST_VM_BASE_IMAGE} \
		${GOTSYSD_TEST_DIR}/vm.qcow2; \
		vmctl start -d ${GOTSYSD_TEST_DIR}/vm.qcow2 -B disk -L \
		${GOTSYSD_VM_NAME}; \
	while sleep 1; do \
		if vmctl status ${GOTSYSD_VM_NAME} | \
		    grep -q ${GOTSYSD_VM_NAME}; then \
			break; \
		fi; \
	done; \
	VMID=`vmctl status ${GOTSYSD_VM_NAME} | tail -n1 | \
		awk '{print $$1}'`; \
	VMIP="100.64.$$VMID.3"; \
	echo "Waiting for VM to finish booting..."; \
	while sleep 1; do \
		if nc -z $${VMIP} ssh; then \
			break; \
		else \
			sleep 5; \
		fi; \
	done; \

${GOTD_CONF}:
	@${UNPRIV} "echo repository gotsys { > $@"
	@${UNPRIV} "echo path \'/git/gotsys.git\' >> $@"
	@${UNPRIV} "echo permit rw ${GOTSYSD_TEST_USER} >> $@"
	@${UNPRIV} "echo } >> $@"

${GOTSYSD_CONF}:
	@${UNPRIV} "echo permit root > $@"
	@${UNPRIV} "echo permit _gotd >> $@"

${GOTSYS_CONF}: ${GOTSYSD_SSH_PUBKEY}
	@${UNPRIV} "echo user ${GOTSYSD_TEST_USER} { >> $@"
	@${UNPRIV} "echo -n \ \ \ \ password \\\" >> $@"
	@${UNPRIV} "echo ${GOTSYSD_VM_PASSWORD} | encrypt | tr -d '\n' >> $@"
	@${UNPRIV} "echo \\\" >> $@"
	@${UNPRIV} "echo } >> $@"
	@${UNPRIV} "echo repository gotsys { >> $@"
	@${UNPRIV} "echo \ \ \ \ permit rw ${GOTSYSD_TEST_USER} >> $@"
	@${UNPRIV} "echo } >> $@"

${GOT_CONF}:
	@${UNPRIV} "echo author \\'${GOTSYSD_TEST_USER} \\<${GOTSYSD_TEST_USER}@localhost\\>\\' > $@"

setup_test_vm: start_test_vm ${GOTD_CONF} ${GOTSYSD_CONF} ${GOTSYS_CONF} ${GOT_CONF}
	@set -e; \
	VMID=`vmctl status ${GOTSYSD_VM_NAME} | tail -n1 | \
		awk '{print $$1}'`; \
	VMIP="100.64.$$VMID.3"; \
	${UNPRIV} "ssh-keygen -R $${VMIP}"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} ${GOTSYSD_TEST_USER}@$${VMIP} \
		mkdir -p src/got bin"; \
	${UNPRIV} "${GOTSYSD_SCP_CMD} -r \
		${.CURDIR}/../../{Makefile*,cvg,got*,git*,lib*,include,tog} \
		${GOTSYSD_TEST_USER}@$${VMIP}:src/got/"; \
	${UNPRIV} "${GOTSYSD_SCP_CMD} build-got.sh \
		${GOTSYSD_TEST_USER}@$${VMIP}:bin/"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} ${GOTSYSD_TEST_USER}@$${VMIP} \
		./bin/build-got.sh"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		make -C /home/${GOTSYSD_TEST_USER}/src/got -- GOT_RELEASE=Yes \
		DEBUG=\\'-Oo -g\\' sysd-install server-install install"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} -- root@$${VMIP} \
		ln -s gitwrapper /usr/local/bin/git-upload-pack"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} -- root@$${VMIP} \
		ln -s gitwrapper /usr/local/bin/git-receive-pack"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} sysctl kern.nosuidcoredump=3"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} mkdir -p /var/crash/gotd "; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} mkdir -p /var/crash/gotsysd "; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} sed -i 's/daemon.info/daemon.*/' /etc/syslog.conf"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} rcctl restart syslogd"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} mkdir -m 700 /git "; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		got init /git/${GOTSYS_REPO}"; \
	${UNPRIV} "${GOTSYSD_SCP_CMD} \
		${GOT_CONF} root@$${VMIP}:/git/${GOTSYS_REPO}/got.conf"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} mkdir /tmp/gotsys "; \
	${UNPRIV} "${GOTSYSD_SCP_CMD} \
		${GOTSYS_CONF} root@$${VMIP}:/tmp/gotsys/"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		got import -m init -r /git/${GOTSYS_REPO} \
		/tmp/gotsys >/dev/null"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		groupadd -g ${GOTD_UID} _gotd"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		useradd -d /nonexistent -s /sbin/nologin \
		-u ${GOTD_UID} -g ${GOTD_UID} _gotd"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		chown -R _gotd:_gotd /git "; \
	${UNPRIV} "${GOTSYSD_SCP_CMD} \
		${GOTD_CONF} root@$${VMIP}:/etc/gotd.conf"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		/usr/local/sbin/gotd -vvv"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		groupadd -g ${GOTSYSD_UID} _gotsysd"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		useradd -d /nonexistent -s /sbin/nologin \
		-u ${GOTSYSD_UID} -g ${GOTSYSD_UID} _gotsysd"; \
	${UNPRIV} "${GOTSYSD_SCP_CMD} \
		${GOTSYSD_CONF} root@$${VMIP}:/etc/gotsysd.conf"; \
	${UNPRIV} "${GOTSYSD_SSH_CMD} root@$${VMIP} \
		/usr/local/sbin/gotsysd -vvv"; \
	
stop_test_vm: ensure_root
	@vmctl stop ${GOTSYSD_VM_NAME}

test_gotsysd: 
	@set -e; \
	VMID=`vmctl status ${GOTSYSD_VM_NAME} | tail -n1 | \
		awk '{print $$1}'`; \
	VMIP="100.64.$$VMID.3"; \
	${UNPRIV} "env ${GOTSYSD_TEST_ENV} VMIP=$${VMIP} sh ./test_gotsysd.sh"

.include <bsd.regress.mk>

=== regress/path/Makefile ===
.PATH:${.CURDIR}/../../lib

PROG = path_test
SRCS = error.c path.c hash.c path_test.c object_parse.c inflate.c pollfd.c \
	object_qid.c

CPPFLAGS = -I${.CURDIR}/../../include -I${.CURDIR}/../../lib
LDADD = -lutil -lz

NOMAN = yes

run-regress-path_test:
	${.OBJDIR}/path_test -q

.include <bsd.regress.mk>

=== debian/changelog ===
got (0.111-1) unstable; urgency=medium

  * New upstream version 0.111
  * Bump standards to 4.7.2
  * Drop upstreamed patches

 -- Tobias Heider <me@tobhe.de>  Wed, 30 Apr 2025 15:25:31 +0200

=== debian/watch ===
version=4

https://gameoftrees.org/releases/portable/got-portable-(.+).tar.gz
